/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package x33eja.sb;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.xml.ws.WebServiceRef;
import x33eja.dto.PersonalRating;
import x33eja.model.Person;
import x33eja.ws.Publication;
import x33eja.ws.ResearchInfoService;

/**
 *
 * @author blcha
 */
@Stateless
public class ResearchCenter implements ResearchCenterLocal {

    @WebServiceRef(wsdlLocation = "META-INF/wsdl/localhost_8081/ResearchService/ResearchInfoService.wsdl")
    private ResearchInfoService service;
    
    @EJB
    SchoolCenterLocal sc;

    public List<PersonalRating> getAllPersonalAcademicRatings() {

        // create map authors --> publications
        Map<String, List<Publication>> authorsPubs = new HashMap();
        for (Publication newPub : getPublications()) {
            for (String author : newPub.getAuthor()) {
                    
                    if (! authorsPubs.containsKey(author)) {
                        authorsPubs.put(author, new LinkedList<Publication>());
                    }
                    authorsPubs.get(author).add(newPub);
            }
        }

        // get all people
        List<Person> people = new LinkedList<Person>();
        people.addAll(sc.getAllTeachers());
        people.addAll(sc.getAllStudents());

        // create personal ratings for all people
        List<PersonalRating> personalRatings = new LinkedList();
        for (Person person : people) {
            String employeeId = getEmployeeId(person.getBirthNumber());

            double finalRating = 0;
            List<Publication> pubs = authorsPubs.get(employeeId);
            if ((employeeId != null) && (pubs != null)) {
                for (Publication p : pubs) {
                    finalRating += p.getRating() / p.getAuthor().size();
                }
            }

            personalRatings.add(new PersonalRating(finalRating, person));
        }

        return personalRatings;
    }

    private java.util.List<x33eja.ws.Publication> getPublications() {
        x33eja.ws.ResearchInfo port = service.getResearchInfoPort();
        return port.getPublications();
    }

    private String getEmployeeId(int birthNumber) {
        x33eja.ws.ResearchInfo port = service.getResearchInfoPort();
        return port.getEmployeeId(birthNumber);
    }



}
